//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame     = PERIOD_CURRENT;
extern int                MaPeriod      = 49;
extern ENUM_MA_METHOD     MaMethod      = MODE_SMA;
extern int                MaShift       = 0;
extern ENUM_APPLIED_PRICE PriceToUse    = PRICE_CLOSE;
extern int                AtrPeriod     = 100;
extern double             AtrMultiplier = 2.0;
extern int                AtrShift      = 0;

double bup[];
double bdn[];
double ma[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
      
      SetIndexBuffer(0,bup); SetIndexShift(0,MaShift*TimeFrame/_Period);
      SetIndexBuffer(1,bdn); SetIndexShift(1,MaShift*TimeFrame/_Period);
      SetIndexBuffer(2,ma);  SetIndexShift(2,MaShift*TimeFrame/_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" Keltner channel ("+MaPeriod+","+DoubleToStr(AtrMultiplier,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bup[0] = MathMin(limit+1,Bars-1); return(0); }
         if (TimeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         double atr = iATR(NULL,TimeFrame,AtrPeriod,y+AtrShift);
            ma[i]  = iMA(NULL,TimeFrame,MaPeriod,0,MaMethod,PriceToUse,y);
            bup[i] =  ma[i]+AtrMultiplier*atr;
            bdn[i] =  ma[i]-AtrMultiplier*atr;
      }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}